import scipy.io
import numpy
import os
import time
from gams import *
import sys


#defining the name and path of input file
currDir = os.path.dirname(os.path.abspath('pyt_export.py'))
fileName = 'Matlab_out.mat'
file_path = currDir+'\\'+fileName


#Starting the GAMS model instance
ws = GamsWorkspace(working_directory=currDir, debug=1)
cp = ws.add_checkpoint()
start = time.time()
job = ws.add_job_from_file("simple.gms")
job.run(checkpoint=cp)
mi = cp.add_modelinstance()
gm = GamsModelInstanceOpt(no_match_limit=1000)  
x0 = mi.sync_db.add_parameter("x0", 0, "Initial state") 
mi.instantiate("mpc us nlp min obj",GamsModifier(x0))
    

while(True):

    while(os.path.isfile(file_path) == False):
        time.sleep(0.1)
    
    #Now we are sure that the Matlab file exists    
    mat = scipy.io.loadmat(file_path)
    os.remove(file_path)  #deleting the Matlab file after importing it
    x = mat['x'];


    x0.clear()
    for rec in job.out_db.get_parameter("x0"):
        x0.add_record(rec.keys).value = float(x[0][0])
    mi.solve(mi_opt = gm)

    u = mi.sync_db["u"].first_record().level  #first control action

    scipy.io.savemat(currDir+'\\Py_out.mat', mdict={'u': u})
    
    
